<?php
// wcf imports
require_once(WCF_DIR.'lib/data/message/bbcode/BBCodeParser.class.php');
require_once(WCF_DIR.'lib/data/message/bbcode/CodeBBCode.class.php');
require_once(WCF_DIR.'lib/data/message/bbcode/highlighter/Highlighter.class.php');

/**
 * Parses many code bbcode tag and highlights the code inside.
 * Currently supported languages: sql, html, xml, js, css, java
 * 
 * @author	Marcel Werk
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.data.message.bbcode.code
 * @subpackage	data.message.bbcode
 * @category 	Community Framework (commercial)
 */
class CodeHighlightingBBCode extends CodeBBCode {
	/**
	 * @see BBCode::getParsedTag()
	 */
	public function getParsedTag($openingTag, $content, $closingTag, BBCodeParser $parser) {
		if ($parser->getOutputType() == 'text/html') {	
			// get highlighter object
			$highlighter = Highlighter::getHighlighter(strtolower($openingTag['name']));
			
			// highlight code
			$content = self::trim($content);
			$highlightedCode = $highlighter->highlight($content);
			
			// show template
			WCF::getTPL()->assign(array(
				'lineNumbers' => $this->makeLineNumbers($highlightedCode, $this->getLineNumbersStart($openingTag)),
				'content' => $highlightedCode,
				'codeBoxName' => WCF::getLanguage()->get('wcf.bbcode.'.$openingTag['name'].'.title')
			));
			return WCF::getTPL()->fetch('codeBBCodeTag');
		}
		else if ($parser->getOutputType() == 'text/plain') {
			return WCF::getLanguage()->get('wcf.bbcode.code.text', array('$content' => $content));
		}
	}
}
?>