<?php
// wcf imports
require_once(WCF_DIR.'lib/data/message/bbcode/highlighter/Highlighter.class.php');

/**
 * Highlights syntax of mysql queries.
 * 
 * @author	Michael Schaefer
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.data.message.bbcode.code
 * @subpackage	data.message.bbcode.highlighter
 * @category 	Community Framework (commercial)
 */
class MysqlHighlighter extends Highlighter {
	// highlighter style
	protected $style = array(
		'quotes' => "color:red",
		'comments' => "color:green",
		'operators' => "color:green",
		'keywords1' => "color:#663821",
		'keywords2' => "color:#871550",
		'numbers' => "color:#1906FD"
	);

	// highlighter syntax
	protected $allowsNewslinesInQuotes = true;
	protected $quotes = array("'", "\"", "`");
	protected $singleLineComment = array("#", "--");
	protected $separators = array("(", ")", ",", ";");
	protected $operators = array("<>", "~=", "!=", "^=", "=", "<", "<=", ">", ">=", "*", "/", "+", "-", "||", "@", "%", "&", "?", "\$");
	protected $keywords1 = array(
		"action",
"add",
"aggregate",
"all",
"alter",
"after",
"and",
"as",
"asc",
"avg",
"avg_row_length",
"auto_increment",
"between",
"bigint",
"bit",
"binary",
"blob",
"bool",
"both",
"by",
"cascade",
"case",
"char",
"character",
"change",
"check",
"checksum",
"column",
"columns",
"comment",
"constraint",
"create",
"cross",
"current_date",
"current_time",
"current_timestamp",
"data",
"database",
"databases",
"date",
"datetime",
"day",
"day_hour",
"day_minute",
"day_second",
"dayofmonth",
"dayofweek",
"dayofyear",
"dec",
"decimal",
"default",
"delayed",
"delay_key_write",
"delete",
"desc",
"describe",
"distinct",
"distinctrow",
"double",
"drop",
"end",
"else",
"escape",
"escaped",
"enclosed",
"enum",
"explain",
"exists",
"fields",
"file",
"first",
"float",
"float4",
"float8",
"flush",
"foreign",
"from",
"for",
"full",
"function",
"global",
"grant",
"grants",
"group",
"having",
"heap",
"high_priority",
"hour",
"hour_minute",
"hour_second",
"hosts",
"identified",
"ignore",
"in",
"index",
"infile",
"inner",
"insert",
"insert_id",
"int",
"integer",
"interval",
"int1",
"int2",
"int3",
"int4",
"int8",
"into",
"if",
"is",
"isam",
"join",
"key",
"keys",
"kill",
"last_insert_id",
"leading",
"left",
"length",
"like",
"lines",
"limit",
"load",
"local",
"lock",
"logs",
"long",
"longblob",
"longtext",
"low_priority",
"max",
"max_rows",
"match",
"mediumblob",
"mediumtext",
"mediumint",
"middleint",
"min_rows",
"minute",
"minute_second",
"modify",
"month",
"monthname",
"myisam",
"natural",
"numeric",
"no",
"not",
"null",
"on",
"optimize",
"option",
"optionally",
"or",
"order",
"outer",
"outfile",
"pack_keys",
"partial",
"password",
"precision",
"primary",
"procedure",
"process",
"processlist",
"privileges",
"read",
"real",
"references",
"reload",
"regexp",
"rename",
"replace",
"restrict",
"returns",
"revoke",
"rlike",
"row",
"rows",
"second",
"select",
"set",
"show",
"shutdown",
"smallint",
"soname",
"sql_big_tables",
"sql_big_selects",
"sql_low_priority_updates",
"sql_log_off",
"sql_log_update",
"sql_select_limit",
"sql_small_result",
"sql_big_result",
"sql_warnings",
"straight_join",
"starting",
"status",
"string",
"table",
"tables",
"temporary",
"terminated",
"text",
"then",
"time",
"timestamp",
"tinyblob",
"tinytext",
"tinyint",
"trailing",
"to",
"type",
"use",
"using",
"unique",
"unlock",
"unsigned",
"update",
"usage",
"values",
"varchar",
"variables",
"varying",
"varbinary",
"with",
"write",
"when",
"where",
"year",
"year_month",
"zerofill"
	);
	protected $keywords2 = array(
		"ABS",
"ACOS",
"ADDDATE",
"ASCII",
"ASIN",
"ATAN",
"ATAN2",
"AVG",
"BENCHMARK",
"BIN",
"CEILING",
"CHAR",
"COALESCE",
"CONCAT",
"CONV",
"COS",
"COT",
"COUNT",
"CURDATE",
"CURTIME",
"DATABASE",
"DAYNAME",
"DAYOFMONTH",
"DAYOFWEEK",
"DAYOFYEAR",
"DECODE",
"DEGREES",
"ELT",
"ENCODE",
"ENCRYPT",
"EXP",
"EXTRACT",
"FIELD",
"FLOOR",
"FORMAT",
"GREATEST",
"HEX",
"HOUR",
"IF",
"IFNULL",
"INSERT",
"INSTR",
"INTERVAL",
"ISNULL",
"LCASE",
"LEAST",
"LEFT",
"LENGTH",
"LOCATE",
"LOCATE",
"LOG",
"LOG10",
"LOWER",
"LPAD",
"LTRIM",
"MAX",
"MD5",
"MID",
"MIN",
"MINUTE",
"MOD",
"MONTH",
"MONTHNAME",
"NOW",
"NULLIF",
"OCT",
"ORD",
"PASSWORD",
"PI",
"POSITION",
"POW",
"POWER",
"prepare",
"QUARTER",
"RADIANS",
"RAND",
"REPEAT",
"REPLACE",
"REVERSE",
"RIGHT",
"ROUND",
"ROUND",
"RPAD",
"RTRIM",
"SECOND",
"SIGN",
"SIN",
"SOUNDEX",
"SPACE",
"SQRT",
"STD",
"STDDEV",
"STRCMP",
"SUBDATE",
"SUBSTRING",
"SUBSTRING",
"SUM",
"SYSDATE",
"TAN",
"TRIM",
"TRUNCATE",
"UCASE",
"UPPER",
"USER",
"VERSION",
"WEEK",
"WEEKDAY",
"YEAR"
	);
}
?>