<?php
// wcf imports
require_once(WCF_DIR.'lib/data/message/bbcode/highlighter/Highlighter.class.php');

/**
 * Highlights syntax of xml documents.
 * 
 * @author	Michael Schaefer
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.data.message.bbcode.code
 * @subpackage	data.message.bbcode.highlighter
 * @category 	Community Framework (commercial)
 */
class XmlHighlighter extends Highlighter {
	// highlighter syntax
	protected $allowsNewslinesInQuotes = true;
	protected $quotes = array("'", "\"");
	protected $singleLineComment = array();
	protected $commentStart = array("<!--");
	protected $commentEnd = array("-->");
	protected $separators = array("<", ">");
	protected $operators = array();
	
	/**
	 * @see	Highlighter::highlightKeywords()
	 */
	protected function highlightKeywords($string) {
		$string = parent::highlightKeywords($string);
		
		// find tags
		$string = preg_replace('~&lt;(?:/|\!|\?)?[a-z0-9]+(?:\s+[a-z0-9]+(?:=[^\s/\?&]+)?)*(?:/|\?)?&gt;~ie', "\$this->highlightTag('\\0')", $string);
		
		return $string;
	}
	
	/**
	 * Highlights an XML tag.
	 */
	protected function highlightTag($tag) {
		// highlight attributes
		$tag = preg_replace('~[a-z0-9]+(?:=[^\s/\?&]+)?(?=\s|&)~i', '<span style="'.$this->style['keywords2'].'">\\0</span>', $tag);
		
		// highlight tag
		return '<span style="'.$this->style['keywords1'].'">'.$tag.'</span>';
	}
}
?>